package org.moddingx.libx.crafting;

import com.google.gson.JsonObject;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.crafting.CraftingHelper;
import net.minecraftforge.registries.ForgeRegistries;

import javax.annotation.Nullable;
import java.util.Objects;

/**
 * Utility functions missing in {@link CraftingHelper}
 */
public class CraftingHelper2 {
    
    public static JsonObject serializeItemStack(ItemStack stack, boolean writeNBT) {
        JsonObject json = new JsonObject();
        json.addProperty("item", Objects.requireNonNull(ForgeRegistries.ITEMS.getKey(stack.m_41720_()), "Can't serialize ItemStack: Item has no registry name: " + stack.m_41720_()).toString());
        json.addProperty("count", stack.m_41613_());
        if (writeNBT) {
            CompoundTag stackTag = stack.m_41782_() ? stack.m_41783_() : null;
            Tag capsTag = forgeCaps(stack);
            if (stackTag != null || capsTag != null) {
                // Need to make a copy, so the stack is not modified.
                CompoundTag resultTag = stackTag == null ? new CompoundTag() : stackTag.m_6426_();
                if (capsTag != null) resultTag.m_128365_("ForgeCaps", capsTag);
                json.addProperty("nbt", resultTag.toString());
            }
        }
        return json;
    }
    
    @Nullable
    private static Tag forgeCaps(ItemStack stack) {
        CompoundTag nbt = stack.serializeNBT();
        if (nbt.m_128441_("ForgeCaps") && (!(nbt.m_128423_("ForgeCaps") instanceof CompoundTag cmp) || !cmp.m_128456_())) {
            return nbt.m_128423_("ForgeCaps");
        } else {
            return null;
        }
    }
}
