package org.moddingx.libx.datagen.provider.recipe;

import net.minecraft.advancements.CriterionTriggerInstance;
import net.minecraft.data.recipes.UpgradeRecipeBuilder;
import net.minecraft.tags.TagKey;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.ItemLike;

import java.util.List;

/**
 * A {@link RecipeExtension} for recipes in the smithing table..
 */
public interface SmithingExtension extends RecipeExtension {

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(ItemLike base, ItemLike addition, ItemLike result) {
        this.smithing(Ingredient.m_43929_(base), Ingredient.m_43929_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(ItemLike base, TagKey<Item> addition, ItemLike result) {
        this.smithing(Ingredient.m_43929_(base), Ingredient.m_204132_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(ItemLike base, Ingredient addition, ItemLike result) {
        this.smithing(Ingredient.m_43929_(base), addition, result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(TagKey<Item> base, ItemLike addition, ItemLike result) {
        this.smithing(Ingredient.m_204132_(base), Ingredient.m_43929_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(TagKey<Item> base, TagKey<Item> addition, ItemLike result) {
        this.smithing(Ingredient.m_204132_(base), Ingredient.m_204132_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(TagKey<Item> base, Ingredient addition, ItemLike result) {
        this.smithing(Ingredient.m_204132_(base), addition, result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(Ingredient base, ItemLike addition, ItemLike result) {
        this.smithing(base, Ingredient.m_43929_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(Ingredient base, TagKey<Item> addition, ItemLike result) {
        this.smithing(base, Ingredient.m_204132_(addition), result);
    }

    /**
     * Adds  a smithing recipe with the given inputs and output.
     */
    default void smithing(Ingredient base, Ingredient addition, ItemLike result) {
        UpgradeRecipeBuilder builder = UpgradeRecipeBuilder.m_126385_(base, addition, result.m_5456_());
        List<CriterionTriggerInstance> criteria = this.criteria(base);
        for (int i = 0; i < criteria.size(); i++) {
            builder.m_126389_("has_item" + i, criteria.get(i));
        }
        builder.m_126395_(this.consumer(), this.provider().loc(result, "smithing"));
    }
}
