package org.moddingx.libx.impl.config.gui.screen;

import net.minecraft.client.gui.components.AbstractWidget;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.network.chat.Component;
import org.lwjgl.glfw.GLFW;
import org.moddingx.libx.impl.config.ConfigImpl;

import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;

public class ConfigSelectScreen extends ConfigBaseScreen {

    private final Function<ConfigImpl, Screen> factory;
    private final List<ConfigImpl> configs;
    private final Screen root;
    
    public ConfigSelectScreen(Function<ConfigImpl, Screen> factory, List<ConfigImpl> configs, Screen root) {
        super(Component.m_237115_("libx.config.gui.selection.title"), null, false);
        this.factory = factory;
        this.configs = configs;
        this.root = root;
    }

    @Override
    protected void buildGui(Consumer<AbstractWidget> consumer) {
        int y = 5;
        int buttonWidth = Math.min(200, this.f_96543_ - 10);
        for (ConfigImpl config : this.configs) {
            consumer.accept(new Button((this.f_96543_ - buttonWidth) / 2, y, buttonWidth, 20, Component.m_237113_(config.id.m_135815_()), button -> this.mc.m_91152_(this.factory.apply(config))));
            y += 25;
        }
    }

    @Override
    public boolean m_7933_(int key, int i1, int i2) {
        // The manager is not available in the select screen, so we need to handle escape ourselves
        if (key == GLFW.GLFW_KEY_ESCAPE && this.m_6913_()) {
            this.mc.m_91152_(this.root);
            return true;
        } else {
            return super.m_7933_(key, i1, i2);
        }
    }
}
