package org.moddingx.libx.impl.config.mappers.advanced;

import com.google.gson.JsonElement;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import org.moddingx.libx.config.gui.ConfigEditor;
import org.moddingx.libx.config.mapper.ValueMapper;
import org.moddingx.libx.config.validator.ValidatorInfo;

public class IngredientValueMapper implements ValueMapper<Ingredient, JsonElement> {

    public static final IngredientValueMapper INSTANCE = new IngredientValueMapper();

    private IngredientValueMapper() {

    }

    @Override
    public Class<Ingredient> type() {
        return Ingredient.class;
    }

    @Override
    public Class<JsonElement> element() {
        return JsonElement.class;
    }

    @Override
    public Ingredient fromJson(JsonElement json) {
        return Ingredient.m_43917_(json);
    }

    @Override
    public JsonElement toJson(Ingredient value) {
        return value.m_43942_();
    }

    @Override
    public Ingredient fromNetwork(FriendlyByteBuf buffer) {
        return Ingredient.m_43940_(buffer);
    }

    @Override
    public void toNetwork(Ingredient value, FriendlyByteBuf buffer) {
        value.m_43923_(buffer);
    }

    @Override
    @OnlyIn(Dist.CLIENT)
    public ConfigEditor<Ingredient> createEditor(ValidatorInfo<?> validator) {
        return ConfigEditor.unsupported(Ingredient.f_43901_);
    }
}
