package org.moddingx.libx.impl.datagen;

import net.minecraft.world.level.block.Block;
import org.moddingx.libx.base.decoration.DecorationContext;
import org.moddingx.libx.datagen.provider.CommonTagsProviderBase;
import org.moddingx.libx.impl.base.decoration.blocks.*;
import org.moddingx.libx.impl.tags.InternalTags;

public class DecorationTags {

    public static void addTags(Block block, CommonTagsProviderBase provider, Runnable initInternal) {
        if (block instanceof DecoratedSlabBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.SLABS).m_126582_(decorated);
            if (decorated.parent.getContext().baseMaterial() == DecorationContext.BaseMaterial.WOOD) {
                provider.block(InternalTags.Blocks.WOODEN_SLABS).m_126582_(decorated);
            }
        } else if (block instanceof DecoratedStairBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.STAIRS).m_126582_(decorated);
            if (decorated.parent.getContext().baseMaterial() == DecorationContext.BaseMaterial.WOOD) {
                provider.block(InternalTags.Blocks.WOODEN_STAIRS).m_126582_(decorated);
            }
        } else if (block instanceof DecoratedWallBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.WALLS).m_126582_(decorated);
        } else if (block instanceof DecoratedFenceBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.FENCES).m_126582_(decorated);
            if (decorated.parent.getContext().baseMaterial() == DecorationContext.BaseMaterial.WOOD) {
                provider.block(InternalTags.Blocks.WOODEN_FENCES).m_126582_(decorated);
            }
        } else if (block instanceof DecoratedFenceGateBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.FENCE_GATES).m_126582_(decorated);
        } else if (block instanceof DecoratedDoorBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.DOORS).m_126582_(decorated);
            if (decorated.parent.getContext().baseMaterial() == DecorationContext.BaseMaterial.WOOD) {
                provider.block(InternalTags.Blocks.WOODEN_DOORS).m_126582_(decorated);
            }
        } else if (block instanceof DecoratedTrapdoorBlock decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.TRAPDOORS).m_126582_(decorated);
            if (decorated.parent.getContext().baseMaterial() == DecorationContext.BaseMaterial.WOOD) {
                provider.block(InternalTags.Blocks.WOODEN_TRAPDOORS).m_126582_(decorated);
            }
        } else if (block instanceof DecoratedWoodButton decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.BUTTONS).m_126582_(decorated);
            provider.block(InternalTags.Blocks.WOODEN_BUTTONS).m_126582_(decorated);
        } else if (block instanceof DecoratedStoneButton decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.BUTTONS).m_126582_(decorated);
        } else if (block instanceof DecoratedPressurePlate decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.PRESSURE_PLATES).m_126582_(decorated);
            switch (decorated.sensitivity) {
                case EVERYTHING -> provider.block(InternalTags.Blocks.WOODEN_PRESSURE_PLATES).m_126582_(decorated);
                case MOBS -> provider.block(InternalTags.Blocks.STONE_PRESSURE_PLATES).m_126582_(decorated);
                default -> {}
            }
        } else if (block instanceof DecoratedSign.Standing decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.SIGNS).m_126582_(decorated);
            provider.block(InternalTags.Blocks.STANDING_SIGNS).m_126582_(decorated);
        } else if (block instanceof DecoratedSign.Wall decorated) {
            initInternal.run();
            provider.block(InternalTags.Blocks.SIGNS).m_126582_(decorated);
            provider.block(InternalTags.Blocks.WALL_SIGNS).m_126582_(decorated);
        }
    }
}
