package org.moddingx.libx.screen.text;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.Style;
import org.lwjgl.glfw.GLFW;
import org.moddingx.libx.impl.screen.text.TextScreenContent;
import org.moddingx.libx.render.RenderHelper;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.Optional;

/**
 * A screen to display some text defined by a {@link ComponentLayout}.
 */
public class TextScreen extends Screen {
    
    private final ComponentLayout layout;
    private final int displayWidth;
    
    @Nullable
    private TextScreenContent content;
    
    public TextScreen(ComponentLayout layout) {
        this(layout, 176);
    }
    
    public TextScreen(ComponentLayout layout, int width) {
        super(Optional.ofNullable(layout.title()).orElse(Component.m_237119_()));
        this.layout = layout;
        this.displayWidth = width;
        this.content = null;
    }

    @Override
    protected void m_7856_() {
        this.content = new TextScreenContent(this.f_96547_, this.displayWidth, this.layout.alignComponents(this.f_96547_, this.displayWidth));
    }

    @Override
    public boolean m_7043_() {
        return false;
    }

    @Override
    public void m_6305_(@Nonnull PoseStack poseStack, int mouseX, int mouseY, float partialTick) {
        this.m_7333_(poseStack);
        if (this.content == null) return;
        int left = (this.f_96543_ - this.content.width()) / 2;
        int top = (this.f_96544_ - this.content.height()) / 2;
        poseStack.m_85836_();
        poseStack.m_85837_(0, 0, 20);
        RenderHelper.renderGuiBackground(poseStack, left - 10, top - 10, this.content.width() + 20, this.content.height() + 20);
        poseStack.m_85837_(0, 0, 20);
        this.content.render(poseStack, left, top);
        Style tooltip = this.content.hoveredStyle(mouseX - left, mouseY - top);
        if (tooltip != null) {
            poseStack.m_85837_(0, 0, 20);
            this.m_96570_(poseStack, tooltip, mouseX, mouseY);
        }
        poseStack.m_85849_();
    }

    @Override
    public boolean m_6375_(double mouseX, double mouseY, int button) {
        if (button == GLFW.GLFW_MOUSE_BUTTON_LEFT && this.content != null) {
            int left = (this.f_96543_ - this.content.width()) / 2;
            int top = (this.f_96544_ - this.content.height()) / 2;
            Style click = this.content.hoveredStyle(((int) mouseX) - left, ((int) mouseY) - top);
            if (click != null) {
                return this.m_5561_(click);
            }
        }
        return super.m_6375_(mouseX, mouseY, button);
    }

    @Override
    protected void m_6697_(@Nonnull String text, boolean overwrite) {
        Minecraft.m_91087_().m_91326_(text);
    }
}
